from matplotlib import pyplot

def get_data():
    # each line: year,male,female
    data = file("life_expectancies_usa.txt", "r").readlines()
    dates = []
    men = []
    women = []
    for point in data:
        date, male, female = point.split(',')
        dates.append(date)
        men.append(male)
        women.append(female)
    return dates, men, women

def plot_expectancies(dates, men, women):
    fig = pyplot.figure()
    ax1 = fig.add_subplot(211)
    ax2 = fig.add_subplot(212)

    ax1.plot(dates, men, label = 'Men')
    ax2.plot(dates, women, label = 'Women')
    ax1.set_ylabel('Age')
    ax1.set_xlabel('Year')
    ax2.set_ylabel('Age')
    ax2.set_xlabel('Year')
    ax1.set_title('Life Expectancy for men')
    ax2.set_title('Life Expectancy for women')
    ax1.legend(loc=2)
    ax2.legend(loc=2)
    
    
dates, male, female = get_data()
plot_expectancies(dates, male, female)
# next two lines
fig = pyplot.gcf() # gcf = get current figure
fig.savefig('life.png')
# same as:
# pyplot.savefig('life.png')

# now deal with crowding
fig.tight_layout()
fig.savefig('life_clean.png')
