import multiprocessing

def start_proc():
    name = multiprocessing.current_process().name
    print "Hi I'm ", name

def count_vowels(text):
    vowels = 0
    for char in text:
        if char in 'aeiou':
           vowels += 1
    return vowels

if __name__ == "__main__":
    # set things up
    nproc = multiprocessing.cpu_count()
    task_pool = multiprocessing.Pool(
              processes=nproc, 
              initializer=start_proc)

    words = "Mary had a little lamb".split()
    
    # do things with map
    map_results = task_pool.map(count_vowels, words)

    # do things with apply_async
    async_results = []
    for word in words:
        async_results.append(
            task_pool.apply_async(count_vowels, 
                                  (word,)))
        
    task_pool.close() # no more tasks
    task_pool.join() # wait here until all 
    
    # print results
    print "\nMap Results"
    print '-'*79
    for word, nvowels in zip(words, map_results):
        print "'{word:s}' has {nvowels:d} vowels".format(word=word,
                                                         nvowels=nvowels)
        
    print "\nAsync Results"
    print '-'*79
    for word, result in zip(words, async_results):
        print "'{word:s}' has {nvowels:d} vowels".format(word=word,
                                                         nvowels=result.get())
        
