#!/usr/bin/env python

import sys
import string

def count_words (filename, n):
    """ Count all unique words in filename, and print top n """
    counts = dict()
    with open(filename, 'r') as fhand:
        for line in fhand:
            line = line.translate(None, string.punctuation)
            line = line.lower()
            words = line.split()
            for word in words:
                if word not in counts:
                    counts[word] = 1
                else:
                    counts[word] += 1
# Sort the dictionary by value
    lst = list()
    for key, val in counts.items():
        lst.append( (val, key) )
    lst.sort(reverse=True)
    for val, key in lst[:n] :
        print val, key


if __name__ == '__main__':
    if len(sys.argv) != 3:
        print('Usage: {0} file n'.format(sys.argv[0]))
        sys.exit(1)
    filename = sys.argv[1]
    n = int(sys.argv[2])
    count_words(filename, n)

