#!/usr/bin/env python

import sys
import string

def count_words (filename, n):
    """ Count all unique words in filename, and print top n """
    counts = {}
    with open(filename, 'r') as fhand:
        for line in fhand:
            line = line.translate(None, string.punctuation).lower()
            words = line.split()
            for word in words:
                counts[word] = counts.get(word, 0) + 1
# Sort the dictionary by value
    sorted_word_list = sorted(counts, reverse=True, key = lambda word: counts[word])
    for key in sorted_word_list[:n] :
        print("{0} {1}".format(counts[key], key))

if __name__ == '__main__':
    if len(sys.argv) != 3:
        print('Usage: {0} file n'.format(sys.argv[0]))
        sys.exit(1)
    filename = sys.argv[1]
    n = int(sys.argv[2])
    count_words(filename, n)

